<?php
/**
* Securitycheck Pro FilesIntegrityStatus Controller
* @ author Jose A. Luque
* @ Copyright (c) 2011 - Jose A. Luque
* @license GNU/GPL v2 or later http://www.gnu.org/licenses/gpl-2.0.html
*/

// Proteccin frente a accesos no autorizados
defined('_JEXEC') or die('Restricted Access');

// Cargamos las clases base
jimport('joomla.application.component.controller');

/**
 * Controlador de la clase FilesIntegrity
 *
 */
class SecuritycheckprosControllerFilesIntegrityStatus extends JControllerLegacy
{

public function  __construct() {
		parent::__construct();
}

/* Mostramos la pantalla Integridad de Archivos */
public function display()
{
	JRequest::setVar( 'view', 'filesintegritystatus' );
	JRequest::setVar('hidemainmenu', 1);
		
	parent::display();
}
	

/* Redirecciona las peticiones al Panel de Control de Integridad de Archivos */
function redireccion_file_integrity_control_panel()
{
	$this->setRedirect( 'index.php?option=com_securitycheckpro&controller=filemanager&task=files_integrity_panel&'. JSession::getFormToken() .'=1' );
}

/* Marca como seguros todos los archivos de la BBDD que aparecen como inseguros. Esto es til cuando hay actualizaciones o la primera vez que lanzamos 'File Integrity' */
function mark_all_unsafe_files_as_safe() {
	
	$model = $this->getModel("filesintegritystatus");
	$model->mark_all_unsafe_files_as_safe();
	JRequest::setVar( 'view', 'filesintegritystatus' );
	JRequest::setVar('hidemainmenu', 1);
		
	parent::display();
}

/* Aade ruta(s) a la lista de excepciones */
function addfile_exception()
{
	$model = $this->getModel("filesintegritystatus");
	$model->addfile_exception('integrity');
	
	JRequest::setVar( 'view', 'filesintegritystatus' );
	
	parent::display();
}

/* Borra ruta(s) de la lista de excepciones */
function deletefile_exception()
{
	$model = $this->getModel("filesintegritystatus");
	$model->deletefile_exception('integrity');
	
	JRequest::setVar( 'view', 'filesintegritystatus' );
	
	parent::display();
}

}