<?php
/**
* Protection Controller para Securitycheck Pro
* @ author Jose A. Luque
* @ Copyright (c) 2011 - Jose A. Luque
* @license GNU/GPL v2 or later http://www.gnu.org/licenses/gpl-2.0.html
*/

// No direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

// Load framework base classes
jimport('joomla.application.component.controller');

/**
* Securitycheckpros  Controller
*
*/
class SecuritycheckprosControllerProtection extends JControllerLegacy
{
/**
* constructor (registers additional tasks to methods)
* @return void
*/
function __construct()
{
parent::__construct();

}

/* Redirecciona las peticiones al componente */
function redireccion()
{
	$this->setRedirect( 'index.php?option=com_securitycheckpro&controller=securitycheckpro' );
}

/* Redirecciona las peticiones al Panel de Control */
function redireccion_control_panel()
{
	$this->setRedirect( 'index.php?option=com_securitycheckpro' );
}

/* Guarda los cambios y redirige al cPanel */
public function save()
{
	JRequest::checkToken() or die('Invalid Token');
	$model = $this->getModel('protection');
	$data = JRequest::get('post');
	$model->saveConfig($data, 'cparams');

	$this->setRedirect('index.php?option=com_securitycheckpro&view=cpanel&'. JSession::getFormToken() .'=1',JText::_('COM_SECURITYCHECKPRO_CONFIGSAVED'));
}

/* Guarda los cambios */
public function apply()
{
	$this->save('cparams');
	$this->setRedirect('index.php?option=com_securitycheckpro&controller=protection&view=protection&'. JSession::getFormToken() .'=1',JText::_('COM_SECURITYCHECKPRO_CONFIGSAVED'));
}

/* Modifica o crear el archivo .htaccess con las configuraciones seleccionadas por el usuario */
function protect()
{
	$model = $this->getModel("protection");

	$status = $model->protect();
	$url = 'index.php?option=com_securitycheckpro&controller=protection&view=protection&'. JSession::getFormToken() .'=1';
	if($status) {
		$this->setRedirect($url,JText::_('COM_SECURITYCHECKPRO_PROTECTION_APPLIED'));
	} else {
		$this->setRedirect($url,JText::_('COM_SECURITYCHECKPRO_PROTECTION_NOTAPPLIED'),'error');
	}
	
}

/* Borra el archivo .htaccess */
function delete_htaccess()
{
	$model = $this->getModel("protection");

	$status = $model->delete_htaccess();
	$url = 'index.php?option=com_securitycheckpro&controller=protection&view=protection&'. JSession::getFormToken() .'=1';
	if($status) {
		$this->setRedirect($url,JText::_('COM_SECURITYCHECKPRO_HTACCESS_DELETED'));
	} else {
		$this->setRedirect($url,JText::_('COM_SECURITYCHECKPRO_HTACCESS_NOT_DELETED'),'error');
	}
	
}

/* Genera una nueva clave para ocultar el backend */
function generate()
{
	$model = $this->getModel("protection");

	$key = $model->generateKey();
	$model->setValue("hide_backend_url",$key,'','cparams');
	$model->save('cparams');	
	$url = 'index.php?option=com_securitycheckpro&controller=protection&view=protection&'. JSession::getFormToken() .'=1';
	$this->setRedirect($url,JText::_('Key Generated'));	
	
}

/* Muestra las configuraciones escogidas en una ventana, en lugar de aplicarlas mediante un archivo .htaccess.  Esto es necesario en servidores NGINX*/
function generate_rules()
{
	// Inicializamos las variables
	$txt_content = '';
	
	$model = $this->getModel("protection");

	$rules = $model->generate_rules();
	
	$txt_content .= $rules;
	// Mandamos el contenido al navegador
	@ob_end_clean();	
	ob_start();	
	header( 'Content-Type: text/plain' );
	header( 'Content-Disposition: attachment;filename=securitycheckpro_nginx_rules.txt' );
	print $txt_content;
	exit();
		
}

}