<?php
/**
* @version		1.5.0
* @ author Jose A. Luque
* @ Copyright (c) 2011 - Jose A. Luque
* @license		GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/

// No Permission
defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.model');

if(!class_exists('JoomlaCompatModel')) {
	if(interface_exists('JModel')) {
		abstract class JoomlaCompatModel extends JModelLegacy {}
	} else {
		class JoomlaCompatModel extends JModel {}
	}
}

class SecuritycheckproModel extends JoomlaCompatModel
{

/**
* Array de datos
* @var array
*/
var $_data;
/**
/**
* Total items
* @var integer
*/
var $_total = null;
/**
/**
* Objeto Pagination
* @var object
*/
var $_pagination = null;
/**
* Columnas de #__securitycheck
* @var integer
*/
var $_dbrows = null;

private $config = null;

private $defaultConfig = array(
	'blacklist'			=> '',
	'whitelist'		=> '',
	'dynamic_blacklist'		=> 1,
	'dynamic_blacklist_time'		=> 600,
	'dynamic_blacklist_counter'		=> 5,
	'blacklist_email'		=> 0,
	'priority'		=> 'Blacklists first',
	'methods'			=> 'GET,POST,REQUEST',
	'mode'			=> 1,
	'logs_attacks'			=> 1,
	'log_limits_per_ip_and_day'			=> 0,
	'redirect_after_attack'			=> 1,
	'redirect_options'			=> 1,
	'second_level'			=> 1,
	'second_level_redirect'			=> 1,
	'second_level_limit_words'			=> 3,
	'second_level_words'			=> 'drop,update,set,admin,select,user,password,concat,login,load_file,ascii,char,union,from,group by,order by,insert,values,pass,where,substring,benchmark,md5,sha1,schema,version,row_count,compress,encode,information_schema,script,javascript,img,src,input,body,iframe,frame',
	'email_active'			=> 0,
	'email_subject'			=> 'Securitycheck Pro alert!',
	'email_body'			=> 'Securitycheck Pro has generated a new alert. Please, check your logs.',
	'email_add_applied_rule'			=> 1,
	'email_to'			=> 'youremail@yourdomain.com',
	'email_from_domain'			=> 'me@mydomain.com',
	'email_from_name'			=> 'Your name',
	'email_max_number'			=> 20,
	'check_header_referer'			=> 1,
	'check_base_64'			=> 1,
	'base64_exceptions'			=> 'com_hikashop',
	'strip_tags_exceptions'			=> 'com_jdownloads,com_hikashop,com_phocaguestbook',
	'duplicate_backslashes_exceptions'			=> 'com_kunena',
	'line_comments_exceptions'			=> 'com_comprofiler',
	'sql_pattern_exceptions'			=> '',
	'if_statement_exceptions'			=> '',
	'using_integers_exceptions'			=> 'com_dms,com_comprofiler,com_jce,com_contactenhanced',
	'escape_strings_exceptions'			=> 'com_kunena,com_jce',
	'lfi_exceptions'			=> '',
	'second_level_exceptions'			=> '',	
	'session_protection_active'			=> 1,
	'session_hijack_protection'			=> 1,
	'tasks'			=> 'alternate',
	'launch_time'			=> 2,
	'periodicity'			=> 1,
	'control_center_enabled'	=> '0',
	'secret_key'	=> '',
);


function __construct()
{
	parent::__construct();

	global $mainframe, $option;
		
	$mainframe = JFactory::getApplication();
 
	// Obtenemos las variables de paginacin de la peticin
	$limit = $mainframe->getUserStateFromRequest('global.list.limit', 'limit', $mainframe->getCfg('list_limit'), 'int');
	$limitstart = JRequest::getVar('limitstart', 0, '', 'int');
	
	// En el caso de que los lmites hayan cambiado, los volvemos a ajustar
	$limitstart = ($limit != 0 ? (floor($limitstart / $limit) * $limit) : 0);
	
	$this->setState('limit', $limit);
	$this->setState('limitstart', $limitstart);	
	
}

protected function populateState()
{
	// Inicializamos las variables
	$app		= JFactory::getApplication();
	
	$extension_type = $app->getUserStateFromRequest('filter.extension_type', 'filter_extension_type');
	$this->setState('filter.extension_type', $extension_type);
	$lists = $app->getUserStateFromRequest('filter.lists_search', 'filter_lists_search');
	$this->setState('filter.lists_search', $lists);
				
	parent::populateState();
}

/* Obtiene el valor de una opcin de configuracin */
public function getValue($key, $default = null, $key_name = 'cparams')
{
	if(is_null($this->config)) $this->load($key_name);
	
	if(version_compare(JVERSION, '3.0', 'ge')) {
		return $this->config->get($key, $default);
	} else {
		return $this->config->getValue($key, $default);
	}
}

/* Establece el valor de una opcin de configuracin ' */
public function setValue($key, $value, $save = false, $key_name = 'cparams')
{
	if(is_null($this->config)) {
		$this->load($key_name);
	}
		
	if(version_compare(JVERSION, '3.0', 'ge')) {
		$x = $this->config->set($key, $value);
	} else {
		$x = $this->config->setValue($key, $value);
	}
	if($save) $this->save($key_name);
	return $x;
}

/* Hace una consulta a la tabla espacificada como parmetro ' */
public function load($key_name)
{
	$db = JFactory::getDBO();
	$query = $db->getQuery(true);
	$query 
		->select($db->quoteName('storage_value'))
		->from($db->quoteName('#__securitycheckpro_storage'))
		->where($db->quoteName('storage_key').' = '.$db->quote($key_name));
	$db->setQuery($query);
	$res = $db->loadResult();
		
	if(version_compare(JVERSION, '3.0', 'ge')) {
		$this->config = new JRegistry();
	} else {
		$this->config = new JRegistry('securitycheckpro');
	}
	if(!empty($res)) {
		$res = json_decode($res, true);
		$this->config->loadArray($res);
	}
}

/* Guarda la configuracin en la tabla pasada como parmetro */
public function save($key_name)
{
	if(is_null($this->config)) {
		$this->load($key_name);
	}
		
	$db = JFactory::getDBO();
	$query = $db->getQuery(true);
	
	$data = $this->config->toArray();
	$data = json_encode($data);
	
	$query
		->delete($db->quoteName('#__securitycheckpro_storage'))
		->where($db->quoteName('storage_key').' = '.$db->quote($key_name));
	$db->setQuery($query);
	$db->query();
		
	$object = (object)array(
		'storage_key'		=> $key_name,
		'storage_value'		=> $data
	);
	$db->insertObject('#__securitycheckpro_storage', $object);
}

/* Obtiene la configuracin de los parmetros del Firewall Web */
function getConfig()
{
	if(interface_exists('JModel')) {
		$params = JModelLegacy::getInstance('FirewallCPanel','SecuritycheckProsModel');
	} else {
		$params = JModel::getInstance('FirewallCPanel','SecuritycheckProsModel');
	}
	
	$config = array();
	foreach($this->defaultConfig as $k => $v) {
		$config[$k] = $params->getValue($k, $v, 'pro_plugin');
	}
	return $config;
}

/* Obtiene la configuracin de los parmetros del Cron */
function getCronConfig()
{
	if(interface_exists('JModel')) {
		$params = JModelLegacy::getInstance('FirewallCPanel','SecuritycheckProsModel');
	} else {
		$params = JModel::getInstance('FirewallCPanel','SecuritycheckProsModel');
	}
	
	$config = array();
	foreach($this->defaultConfig as $k => $v) {
		$config[$k] = $params->getValue($k, $v, 'cron_plugin');
	}
	return $config;
}

/* Obtiene la configuracin de los parmetros del Control Center */
function getControlCenterConfig()
{
	if(interface_exists('JModel')) {
		$params = JModelLegacy::getInstance('FirewallCPanel','SecuritycheckProsModel');
	} else {
		$params = JModel::getInstance('FirewallCPanel','SecuritycheckProsModel');
	}
	
	$config = array();
	foreach($this->defaultConfig as $k => $v) {
		$config[$k] = $params->getValue($k, $v, 'controlcenter');
	}
	return $config;
}

/* Guarda la modificacin de los parmetros de la opcin 'Mode' */
function saveConfig($newParams, $key_name = 'cparams')
{
	if(interface_exists('JModel')) {
		$params = JModelLegacy::getInstance('FirewallCPanel','SecuritycheckProsModel');
	} else {
		$params = JModel::getInstance('FirewallCPanel','SecuritycheckProsModel');
	}

	foreach($newParams as $key => $value)
	{
		// Do not save unnecessary parameters
		if(!array_key_exists($key, $this->defaultConfig)) continue;
		$params->setValue($key,$value,'',$key_name);
	}
	
	$params->save($key_name);
}

/* Limpia un string de caracteres no vlidos segn la opcin especificada */
function clearstring($string_to_clear, $option = 1)
{
	// Eliminamos espacios y retornos de carro entre los elementos
	switch ($option) {
		case 1:
			// Transformamos el string array para poder manejarlo mejor
			$string_to_array = explode(',',$string_to_clear);
			// Eliminamos los espacios en blanco al principio y al final de cada elemento
			$string_to_array = array_map( function ($element) { return trim($element); },$string_to_array );
			// Eliminamos los retornos de carro, nuevas lneas y tabuladores de cada elemento
			$string_to_array = array_map( function ($element) { return str_replace(array("\n", "\t", "\r"), '', $element); },$string_to_array );
			// Volvemos a convertir el array en string
			$string_to_clear = implode(',',$string_to_array);
			break;
		case 2:
			$string_to_clear = str_replace(array(" ", "\n", "\t", "\r"), '', $string_to_clear);
			break;
	} 
		
	return $string_to_clear;
}

/* Funcin para chequear si una ip pertenece a una lista en la que podemos especificar rangos. Podemos tener una ip del tipo 192.168.*.* y una ip 192.168.1.1 entrara en ese rango */
function chequear_ip_en_lista($ip,$lista){
	$aparece = false;
	$array_ip_peticionaria = explode('.',$ip);
		
	if (strlen($lista) > 0) {
		// Eliminamos los caracteres en blanco antes de introducir los valores en el array
		$lista = str_replace(' ','',$lista);
		$array_ips = explode(',',$lista);
		if ( is_int(array_search($ip,$array_ips)) ){	// La ip aparece tal cual en la lista
			$aparece = true;
		} else {
			foreach ($array_ips as &$indice){
					if (strrchr($indice,'*')){ // Chequeamos si existe el carcter '*' en el string; si no existe podemos ignorar esta ip
					$array_ip_lista = explode('.',$indice); // Formato array:  $array_ip_lista[0] = '192' , $array_ip_lista[1] = '168'
					$k = 0;
					$igual = true;
					while (($k <= 3) && ($igual)) {
						if ($array_ip_lista[$k] == '*') {
							$k++;
						}else {
							if ($array_ip_lista[$k] == $array_ip_peticionaria[$k]) {
								$k++;
							} else {
								$igual = false;
							}
						}
					}
					if ($igual) { // $igual ser true cuando hayamos recorrido el array y todas las partes del mismo coincidan con la ip que realiza la peticin
						$aparece = true;
						return $aparece;
					}
				}
			}
		}
	}
	return $aparece;
}

/* Funcin que cifra un texto usando AES128 con el modo CBC */
function mc_encrypt_128($encrypt, $key){
	$encrypt = serialize($encrypt);
	$iv = mcrypt_create_iv(mcrypt_get_iv_size(MCRYPT_RIJNDAEL_128, MCRYPT_MODE_CBC), MCRYPT_DEV_RANDOM);
	$passcrypt = mcrypt_encrypt(MCRYPT_RIJNDAEL_128, $key, $encrypt, MCRYPT_MODE_CBC, $iv);
	$encoded = base64_encode($passcrypt).'|'.base64_encode($iv);
	return $encoded;
}
 
/* Funcin que descifra un texto usando AES128 con el modo CBC */
function mc_decrypt_128($decrypt, $key){
	$decrypt = explode('|', $decrypt);
	$decoded = base64_decode($decrypt[0]);
	$iv = base64_decode($decrypt[1]);
	$decrypted = trim(mcrypt_decrypt(MCRYPT_RIJNDAEL_128, $key, $decoded, MCRYPT_MODE_CBC, $iv));
	$decrypted = unserialize($decrypted);
return $decrypted;
}

/* Funcin que cifra un texto usando AES256 con el modo CBC */
function mc_encrypt_256($encrypt, $key){
	$encrypt = serialize($encrypt);
	$iv = mcrypt_create_iv(mcrypt_get_iv_size(MCRYPT_RIJNDAEL_256, MCRYPT_MODE_CBC), MCRYPT_DEV_RANDOM);
	$passcrypt = mcrypt_encrypt(MCRYPT_RIJNDAEL_256, $key, $encrypt, MCRYPT_MODE_CBC, $iv);
	$encoded = base64_encode($passcrypt).'|'.base64_encode($iv);
	return $encoded;
}
 
/* Funcin que descifra un texto usando AES256 con el modo CBC */
function mc_decrypt_256($decrypt, $key){
	$decrypt = explode('|', $decrypt);
	$decoded = base64_decode($decrypt[0]);
	$iv = base64_decode($decrypt[1]);
	$decrypted = trim(mcrypt_decrypt(MCRYPT_RIJNDAEL_256, $key, $decoded, MCRYPT_MODE_CBC, $iv));
	$decrypted = unserialize($decrypted);
return $decrypted;
}

/* Funcin que modifica el valor de algn parmetro de un componente */
function modify_component_value($param_name,$value,$option) {

	// Inicializamos las variables
	$added = true;
	$deleted = true;
	$already_exists = false;
	$new_value = null;
	
	// Get the params and set the new values
	$params = JComponentHelper::getParams('com_securitycheckpro');
	$actual_values = $params->get($param_name,null);
		
	if ( $option == "add" ) {
		
		if ( is_null($actual_values) ) {
			$actual_values =  $value;
		} else {
			if ( strstr($actual_values,$value) ) {  // El path ya se encuentra incluido como excepcion
				$already_exists = true;
			}
			$actual_values .= "," . $value;
		}
		
		if ( !$already_exists ) {  // El elemento no existe en la lista
		
			$params->set($param_name, $actual_values);

			// Get a new database query instance
			$db = JFactory::getDBO();
			$query = $db->getQuery(true);

			// Build the query
			$query->update('#__extensions AS a');
			$query->set('a.params = ' . $db->quote((string)$params));
			$query->where('a.element = "com_securitycheckpro"');

			// Execute the query
			$db->setQuery($query);
			$db->query();
		} else {
			$added = false;
		}
		
		return $added;
	} else if ( $option == "delete" ) {
	
		if ( is_null($actual_values) ) {
			$actual_values =  $value;
		} else {
			
			// Convertimos todas las excepciones en un array
			$array_values = explode(',',$actual_values);
			
			// Buscamos el ndice del array que contiene la ruta que queremos borrar...
			$indice_elemento = array_search($value,$array_values);
			
			// ... y lo eliminamos
			unset($array_values[$indice_elemento]);
			
			// Reorganizamos el array...
			$new_array = array_values($array_values);			
			
			// ... y lo volvemos a convertir en string
			$new_value = implode(',',$new_array);
			
			// El valor se ha encontrado
			if ( is_int($indice_elemento) ) {
				$params->set($param_name, $new_value);

				// Get a new database query instance
				$db = JFactory::getDBO();
				$query = $db->getQuery(true);

				// Build the query
				$query->update('#__extensions AS a');
				$query->set('a.params = ' . $db->quote((string)$params));
				$query->where('a.element = "com_securitycheckpro"');

				// Execute the query
				$db->setQuery($query);
				$db->query();			
			} else {
				$deleted = false;
			}
			
			return $deleted;
		}
	}
}

/* Funcin que aade una ruta  a la lista de excepciones */
function addfile_exception($type) {
	// Inicializamos las variables
	$added_elements = 0;
	$already_exists_elements = 0;
	$option = 'file_integrity_path_exceptions';
	
	// Parmetros de la aplicacin
	$params = JComponentHelper::getParams('com_securitycheckpro');
	
	$db = JFactory::getDBO();
	
	// Creamos el objeto JInput para obtener las variables del formulario
	$jinput = JFactory::getApplication()->input;
	
	if ($type == 'malwarescan') {
		// Obtenemos las rutas de los ficheros que sern aadidas como excepciones
		$paths = $jinput->get('malwarescan_status_table','0','array');
		
		// Usamos nuestra propia lista de excepciones o la del escaneo de integridad?
		$use_filemanager_exceptions = $params->get('use_filemanager_exceptions',1);
		if ( !$use_filemanager_exceptions ) {
			$option = 'malwarescan_path_exceptions';
		}
	} else if ($type == 'permissions') {
		// Obtenemos las rutas de los ficheros que sern aadidas como excepciones
		$paths = $jinput->get('filesstatus_table','0','array');
		
		$option = 'file_manager_path_exceptions';
	} else if ($type == 'integrity') {
		// Obtenemos las rutas de los ficheros que sern aadidas como excepciones
		$paths = $jinput->get('filesintegritystatus_table','0','array');		
	}
	
	if ( !empty($paths) ) {	
		foreach($paths as $path) {
			// Path sanitizada
			$sanitized_path = $db->escape($path);
			// Agregamos el archivo a la lista de excepciones
			$added = $this->modify_component_value($option,$sanitized_path,'add');
			if ( $added ) {
				$added_elements++;
			} else {
				$already_exists_elements++;
			}
		}
	}
	
	JFactory::getApplication()->enqueueMessage(JText::sprintf('COM_SECURITYCHECKPRO_ELEMENTS_ADDED_TO_LIST',$added_elements));
	if ( $added_elements > 0 ) {
		Jerror::raiseNotice(100, JText::_('COM_SECURITYCHECKPRO_ELEMENTS_LAUNCH_NEW_SCAN'));
	}
	if ( $already_exists_elements > 0 ) {
		Jerror::raiseWarning(100, JText::sprintf('COM_SECURITYCHECKPRO_ELEMENTS_ALREADY_EXISTS',$already_exists_elements));
	}
}

/* Funcin que borra una ruta de la lista de excepciones */
function deletefile_exception($type) {
	// Inicializamos las variables
	$deleted_elements = 0;
	$option = 'file_integrity_path_exceptions';
	
	// Parmetros de la aplicacin
	$params = JComponentHelper::getParams('com_securitycheckpro');
	
	$db = JFactory::getDBO();
	
	// Creamos el objeto JInput para obtener las variables del formulario
	$jinput = JFactory::getApplication()->input;
	
	if ($type == 'malwarescan') {
		// Obtenemos las rutas de los ficheros que sern aadidas como excepciones
		$paths = $jinput->get('malwarescan_status_table','0','array');
		
		// Usamos nuestra propia lista de excepciones o la del escaneo de integridad?
		$use_filemanager_exceptions = $params->get('use_filemanager_exceptions',1);
		if ( !$use_filemanager_exceptions ) {
			$option = 'malwarescan_path_exceptions';
		}
	} else if ($type == 'permissions') {
		// Obtenemos las rutas de los ficheros que sern aadidas como excepciones
		$paths = $jinput->get('filesstatus_table','0','array');
				
		$option = 'file_manager_path_exceptions';
	} else if ($type == 'integrity') {
		// Obtenemos las rutas de los ficheros que sern aadidas como excepciones
		$paths = $jinput->get('filesintegritystatus_table','0','array');		
	}
	
	if ( !empty($paths) ) {	
		foreach($paths as $path) {
			// Path sanitizada
			$sanitized_path = $db->escape($path);
			// Agregamos el archivo a la lista de excepciones
			$deleted = $this->modify_component_value($option,$sanitized_path,'delete');
			if ( $deleted ) {
				$deleted_elements++;
			}
		}
	}
	
	JFactory::getApplication()->enqueueMessage(JText::sprintf('COM_SECURITYCHECKPRO_ELEMENTS_DELETED_FROM_LIST',$deleted_elements));
	if ( $deleted_elements > 0 ) {
		Jerror::raiseNotice(100, JText::_('COM_SECURITYCHECKPRO_ELEMENTS_LAUNCH_NEW_SCAN'));
	}	
}

/*Genera un nombre de fichero .php  de 20 caracteres */
function generateKey() {
	
	$chars = "abcdefghijklmnopqrstuvwxyz0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ"; //available characters
	srand( ( double ) microtime() * 1000000 ); //random seed
	$pass = '' ;
		
	for ( $i = 1; $i <= 20; $i++ ) {
		$num = rand() % 33;
		$tmp = substr( $chars, $num, 1 );
		$pass = $pass . $tmp;
	}

	return $pass.'.php';	
}

/* Funcin para determinar si el plugin pasado como argumento ('1' -> Securitycheck Pro, '2' -> Securitycheck Pro Cron, '3' -> Securitycheck Pro Update Database) est habilitado o deshabilitado. Tambin determina si el plugin Securitycheck Pro Update Database (opcin 4)  est instalado */
function PluginStatus($opcion) {
		
	$db = JFactory::getDBO();
	if ( $opcion == 1 ) {
		$query = 'SELECT enabled FROM #__extensions WHERE name="System - Securitycheck Pro"';
	} else if ( $opcion == 2 ) {
		$query = 'SELECT enabled FROM #__extensions WHERE name="System - Securitycheck Pro Cron"';
	} else if ( $opcion == 3 ) {
		$query = 'SELECT enabled FROM #__extensions WHERE name="System - Securitycheck Pro Update Database"';
	} else if ( $opcion == 4 ) {
		$query = 'SELECT COUNT(*) FROM #__extensions WHERE name="System - Securitycheck Pro Update Database"';
	}
	
	$db->setQuery( $query );
	$db->query();
	$enabled = $db->loadResult();
	
	return $enabled;
}

/* Funcin que consulta el valor de una bbdd pasados como argumentos */
function get_campo_bbdd($bbdd,$campo)
{
	// Creamos el nuevo objeto query
	$db = JFactory::getDbo();
		
	// Consultamos el campo de la bbdd
	$query = $db->getQuery(true)
		->select($db->quoteName($campo))
		->from($db->quoteName('#__' . $bbdd));
	$db->setQuery($query);
	$valor = $db->loadResult();
	
	return $valor;
}


}