<?php
/**
* Geoblock Model para el Componente Securitycheckpro
* @ author Jose A. Luque
* @ Copyright (c) 2011 - Jose A. Luque
* @license GNU/GPL v2 or later http://www.gnu.org/licenses/gpl-2.0.html
 */

// Protect from unauthorized access
defined('_JEXEC') or die();

if(!class_exists('JoomlaCompatModel')) {
	if(interface_exists('JModel')) {
		abstract class JoomlaCompatModel extends JModelLegacy {}
	} else {
		class JoomlaCompatModel extends JModel {}
	}
}

/**
* Modelo Securitycheck
*/
class SecuritycheckprosModelGeoblock extends JoomlaCompatModel
{

	
/* Definimos las variables */
var $defaultConfig = array(
	'geoblockcountries'	=> '',
	'geoblockcontinents'	=> '',
);
	
	private $config = null;

/* Obtiene el valor de una opcin de configuracin de 'htaccess protection' */
public function getValue($key, $default = null, $key_name = 'geoblock')
{
	if(is_null($this->config)) $this->load($key_name);
	
	if(version_compare(JVERSION, '3.0', 'ge')) {
		return $this->config->get($key, $default);
	} else {
		return $this->config->getValue($key, $default);
	}
}

/* Establece el valor de una opcin de configuracin de 'htaccess protection' */
public function setValue($key, $value, $save = false, $key_name = 'geoblock')
{
	if(is_null($this->config)) {
		$this->load($key_name);
	}
		
	if(version_compare(JVERSION, '3.0', 'ge')) {
		$x = $this->config->set($key, $value);
	} else {
		$x = $this->config->setValue($key, $value);
	}
	if($save) $this->save($key_name);
	return $x;
}

/* Hace una consulta a la tabla #__securitycheckpro_storage, que contiene la configuracin de 'htaccess protection' */
public function load($key_name)
{
	$db = JFactory::getDBO();
	$query = $db->getQuery(true);
	$query 
		->select($db->quoteName('storage_value'))
		->from($db->quoteName('#__securitycheckpro_storage'))
		->where($db->quoteName('storage_key').' = '.$db->quote($key_name));
	$db->setQuery($query);
	$res = $db->loadResult();
	
	if(version_compare(JVERSION, '3.0', 'ge')) {
		$this->config = new JRegistry();
	} else {
		$this->config = new JRegistry('securitycheckpro');
	}
	if(!empty($res)) {
		$res = json_decode($res, true);		
		 $this->config->loadArray($res);		
	}
	
}

/* Guarda la configuracin de 'htaccess protection' con a la tabla #__securitycheckpro_storage */
public function save($key_name)
{
	if(is_null($this->config)) {
		$this->load($key_name);
	}
		
	$db = JFactory::getDBO();
	$query = $db->getQuery(true);
	
	$data = $this->config->toArray();
	$data = json_encode($data);
		
	$query
		->delete($db->quoteName('#__securitycheckpro_storage'))
		->where($db->quoteName('storage_key').' = '.$db->quote($key_name));
	$db->setQuery($query);
	$db->query();
		
	$object = (object)array(
		'storage_key'		=> $key_name,
		'storage_value'		=> $data
	);
	$db->insertObject('#__securitycheckpro_storage', $object);
}

/* Obtiene la configuracin de los parmetros de la opcin 'Protection' */
function getConfig()
{
	$config = array();
	foreach($this->defaultConfig as $k => $v) {
		$config[$k] = $this->getValue($k, $v);
	}
	
	return $config;
}

/* Guarda la modificacin de los parmetros de la opcin 'Protection' */
function saveConfig($newParams, $key_name = 'geoblock')
{
	foreach($newParams as $key => $value)
	{
		$this->setValue($key,$value,'',$key_name);
	}

	$this->save($key_name);
}
	
}