<?php
/**
* Securitycheck Pro Protection View para el Componente Securitycheckpro
* @ author Jose A. Luque
* @ Copyright (c) 2011 - Jose A. Luque
* @license GNU/GPL v2 or later http://www.gnu.org/licenses/gpl-2.0.html
*/

// Protect from unauthorized access
defined('_JEXEC') or die();
JRequest::checkToken( 'get' ) or die( 'Invalid Token' );

$script = <<<ENDSCRIPT
window.addEvent( 'domready' ,  function() {
	$('generate').addEvent('click',function(e){
		e.preventDefault();
		$('task').setProperty('value','generate');
		document.forms.adminForm.submit();
	});
});
ENDSCRIPT;
$document = JFactory::getDocument();
$document->addScriptDeclaration($script,'text/javascript');

function booleanlist( $name, $attribs = null, $selected = null, $id=false )
{
	$arr = array(
		JHTML::_('select.option',  '0', JText::_( 'COM_SECURITYCHECKPRO_NO' ) ),
		JHTML::_('select.option',  '1', JText::_( 'COM_SECURITYCHECKPRO_YES' ) )
	);
	return JHTML::_('select.genericlist',  $arr, $name, $attribs, 'value', 'text', (int) $selected, $id );
}

function xframeoptions( $name, $attribs = null, $selected = null, $id=false )
{
	$arr = array(
		JHTML::_('select.option',  'NO', JText::_( 'COM_SECURITYCHECKPRO_NO' ) ),
		JHTML::_('select.option',  'DENY', JText::_( 'COM_SECURITYCHECKPRO_XFRAME_OPTIONS_DENY' ) ),
		JHTML::_('select.option',  'SAMEORIGIN', JText::_( 'COM_SECURITYCHECKPRO_XFRAME_OPTIONS_SAMEORIGIN' ) )
	);
	return JHTML::_('select.genericlist',  $arr, $name, $attribs, 'value', 'text', $selected, $id );
}

JHTML::_( 'behavior.framework' );

// Add style declaration
$media_url = "media/com_securitycheckpro/stylesheets/cpanelui.css";
JHTML::stylesheet($media_url);

$bootstrap_css = "media/com_securitycheckpro/stylesheets/bootstrap.min.css";
JHTML::stylesheet($bootstrap_css);

$site_url = JURI::base();
?>

<div class="securitycheck-bootstrap">
<?php
	if ($this->server == 'apache'){
?>
<div class="alert alert-warn">
	<?php echo JText::_('COM_SECURITYCHECKPRO_USER_AGENT_INTRO'); ?>
</div>
<div class="alert alert-error">
	<?php echo JText::_('COM_SECURITYCHECKPRO_USER_AGENT_WARN'); ?>	
</div>
<div class="alert alert-info">
<?php if($this->ExistsHtaccess) { 
		echo JText::_('COM_SECURITYCHECKPRO_USER_AGENT_HTACCESS');
	  } else { 
	  	echo JText::_('COM_SECURITYCHECKPRO_USER_AGENT_NO_HTACCESS');
} ?>
</div>
<?php
	} else if ($this->server == 'nginx'){
?>
<div class="alert alert-error">
	<?php echo JText::_('COM_SECURITYCHECKPRO_NGINX_SERVER'); ?>	
</div>
<?php
	}
?>

<form action="index.php" name="adminForm" id="adminForm" method="post" class="form form-horizontal">
	<input type="hidden" name="option" value="com_securitycheckpro" />
	<input type="hidden" name="view" value="protection" />
	<input type="hidden" name="boxchecked" value="1" />
	<input type="hidden" name="task" id="task" value="save" />
	<input type="hidden" name="controller" value="protection" />
	<?php echo JHTML::_( 'form.token' ); ?>
	
	<fieldset>
		<legend><?php echo JText::_('COM_SECURITYCHECKPRO_PROTECTION_AUTOPROTECTION_TEXT') ?></legend>
		
		<div class="control-group">
			<label for="own_banned_list" class="control-label-more-width" title="<?php echo JText::_('COM_SECURITYCHECKPRO_PREVENT_ACCESS_EXPLAIN') ?>"><?php echo JText::_('COM_SECURITYCHECKPRO_PREVENT_ACCESS_TEXT'); ?></label>
			<div class="controls controls-row">
				<?php echo booleanlist('prevent_access', array(), $this->protection_config['prevent_access']) ?>
				<?php if ( $this->config_applied['prevent_access'] ) {?>
					<span class="help-inline">
						<div class="applied">
							<?php echo JText::_('COM_SECURITYCHECKPRO_APPLIED') ?>
						</div>
					</span>
				<?php } ?>
			</div>
			<blockquote><p class="text-info"><small><?php echo JText::_('COM_SECURITYCHECKPRO_PREVENT_ACCESS_EXPLAIN') ?></small></p></blockquote>
		</div>
		<div class="control-group">
			<label for="own_banned_list" class="control-label-more-width" title="<?php echo JText::_('COM_SECURITYCHECKPRO_PREVENT_UNAUTHORIZED_BROWSING_EXPLAIN') ?>"><?php echo JText::_('COM_SECURITYCHECKPRO_PREVENT_UNAUTHORIZED_BROWSING_TEXT'); ?></label>
			<div class="controls controls-row">
				<?php echo booleanlist('prevent_unauthorized_browsing', array(), $this->protection_config['prevent_unauthorized_browsing']) ?>
				<?php if ( $this->config_applied['prevent_unauthorized_browsing'] ) {?>
					<span class="help-inline">
						<div class="applied">
							<?php echo JText::_('COM_SECURITYCHECKPRO_APPLIED') ?>
						</div>
					</span>
				<?php } ?>
			</div>
			<blockquote><p class="text-info"><small><?php echo JText::_('COM_SECURITYCHECKPRO_PREVENT_UNAUTHORIZED_BROWSING_EXPLAIN') ?></small></p></blockquote>
		</div>
		<div class="control-group">
			<label for="own_banned_list" class="control-label-more-width" title="<?php echo JText::_('COM_SECURITYCHECKPRO_FILE_INJECTION_PROTECTION_EXPLAIN') ?>"><?php echo JText::_('COM_SECURITYCHECKPRO_FILE_INJECTION_PROTECTION_TEXT'); ?></label>
			<div class="controls controls-row">
				<?php echo booleanlist('file_injection_protection', array(), $this->protection_config['file_injection_protection']) ?>
				<?php if ( $this->config_applied['file_injection_protection'] ) {?>
					<span class="help-inline">
						<div class="applied">
							<?php echo JText::_('COM_SECURITYCHECKPRO_APPLIED') ?>
						</div>
					</span>
				<?php } ?>
			</div>
			<blockquote><p class="text-info"><small><?php echo JText::_('COM_SECURITYCHECKPRO_FILE_INJECTION_PROTECTION_EXPLAIN') ?></small></p></blockquote>
		</div>
		<div class="control-group">
			<label for="own_banned_list" class="control-label-more-width" title="<?php echo JText::_('COM_SECURITYCHECKPRO_SELF_ENVIRON_EXPLAIN') ?>"><?php echo JText::_('COM_SECURITYCHECKPRO_SELF_ENVIRON_TEXT'); ?></label>
			<div class="controls controls-row">
				<?php echo booleanlist('self_environ', array(), $this->protection_config['self_environ']) ?>
				<?php if ( $this->config_applied['self_environ'] ) {?>
					<span class="help-inline">
						<div class="applied">
							<?php echo JText::_('COM_SECURITYCHECKPRO_APPLIED') ?>
						</div>
					</span>
				<?php } ?>
			</div>
			<blockquote><p class="text-info"><small><?php echo JText::_('COM_SECURITYCHECKPRO_SELF_ENVIRON_EXPLAIN') ?></small></p></blockquote>
		</div>
	</fieldset>
	
	<fieldset>
		<legend><?php echo JText::_('COM_SECURITYCHECKPRO_HTTP_HEADERS_PROTECTION_TEXT') ?></legend>
		
		<div class="alert alert-error">
			<?php echo JText::_('COM_SECURITYCHECKPRO_HTTP_HEADERS_EXPLAIN'); ?>	
		</div>
		
		<div class="control-group">
			<label for="xframe_options" class="control-label-more-width" title="<?php echo JText::_('COM_SECURITYCHECKPRO_XFRAME_OPTIONS_EXPLAIN') ?>"><?php echo JText::_('COM_SECURITYCHECKPRO_XFRAME_OPTIONS_TEXT'); ?></label>
			<div class="controls controls-row">
				<?php echo xframeoptions('xframe_options', array(), $this->protection_config['xframe_options']) ?>
				<?php if ( $this->config_applied['xframe_options'] ) {?>
					<span class="help-inline">
						<div class="applied">
							<?php echo JText::_('COM_SECURITYCHECKPRO_APPLIED') ?>
						</div>
					</span>
				<?php } ?>
			</div>
			<blockquote><p class="text-info"><small><?php echo JText::_('COM_SECURITYCHECKPRO_XFRAME_OPTIONS_EXPLAIN') ?></small></p></blockquote>
		</div>
		<div class="control-group">
			<label for="prevent_mime_attacks" class="control-label-more-width" title="<?php echo JText::_('COM_SECURITYCHECKPRO_PREVENT_MIME_ATTACKS_EXPLAIN') ?>"><?php echo JText::_('COM_SECURITYCHECKPRO_PREVENT_MIME_ATTACKS_TEXT'); ?></label>
			<div class="controls controls-row">
				<?php echo booleanlist('prevent_mime_attacks', array(), $this->protection_config['prevent_mime_attacks']) ?>
				<?php if ( $this->config_applied['prevent_mime_attacks'] ) {?>
					<span class="help-inline">
						<div class="applied">
							<?php echo JText::_('COM_SECURITYCHECKPRO_APPLIED') ?>
						</div>
					</span>
				<?php } ?>
			</div>
			<blockquote><p class="text-info"><small><?php echo JText::_('COM_SECURITYCHECKPRO_PREVENT_MIME_ATTACKS_EXPLAIN') ?></small></p></blockquote>
		</div>
		
	</fieldset>
	
	<fieldset>
		<legend><?php echo JText::_('COM_SECURITYCHECKPRO_PROTECTION_USER_AGENTS_TEXT') ?></legend>
		
		<div class="control-group">
			<label for="default_banned_list" class="control-label-more-width" title="<?php echo JText::_('COM_SECURITYCHECKPRO_DEFAULT_BANNED_LIST_EXPLAIN') ?>"><?php echo JText::_('COM_SECURITYCHECKPRO_DEFAULT_BANNED_LIST_TEXT'); ?></label>
			<div class="controls controls-row">
				<?php echo booleanlist('default_banned_list', array(), $this->protection_config['default_banned_list']) ?>
				<?php if ( $this->config_applied['default_banned_list'] ) {?>
					<span class="help-inline">
						<div class="applied">
							<?php echo JText::_('COM_SECURITYCHECKPRO_APPLIED') ?>
						</div>
					</span>
				<?php } ?>
			</div>
			<blockquote><p class="text-info"><small><?php echo JText::_('COM_SECURITYCHECKPRO_DEFAULT_BANNED_LIST_EXPLAIN') ?></small></p></blockquote>
		</div>
		<div class="control-group">
			<label for="own_banned_list" class="control-label-more-width" title="<?php echo JText::_('COM_SECURITYCHECKPRO_OWN_BANNED_LIST_EXPLAIN') ?>"><?php echo JText::_('COM_SECURITYCHECKPRO_OWN_BANNED_LIST_TEXT'); ?></label>
			<div class="controls controls-row">
				<textarea rows="5" cols="55" name="own_banned_list" id="own_banned_list"><?php echo $this->protection_config['own_banned_list'] ?></textarea>
				<?php if ( $this->config_applied['own_banned_list'] ) {?>
					<span class="help-inline">
						<div class="applied">
							<?php echo JText::_('COM_SECURITYCHECKPRO_APPLIED') ?>
						</div>
					</span>
				<?php } ?>
			</div>
			<blockquote><p class="text-info"><small><?php echo JText::_('COM_SECURITYCHECKPRO_OWN_BANNED_LIST_EXPLAIN') ?></small></p></blockquote>
		</div>
	</fieldset>
	
	<fieldset>
		<legend><?php echo JText::_('COM_SECURITYCHECKPRO_FINGERPRINTING_PROTECTION_TEXT') ?></legend>
		
		<div class="alert alert-error">
			<?php echo JText::_('COM_SECURITYCHECKPRO_FINGERPRINTING_EXPLAIN'); ?>	
		</div>
		<div class="control-group">
			<label for="default_banned_list" class="control-label-more-width" title="<?php echo JText::_('COM_SECURITYCHECKPRO_DISABLE_SERVER_SIGNATURE_EXPLAIN') ?>"><?php echo JText::_('COM_SECURITYCHECKPRO_DISABLE_SERVER_SIGNATURE_TEXT'); ?></label>
			<div class="controls controls-row">
				<?php echo booleanlist('disable_server_signature', array(), $this->protection_config['disable_server_signature']) ?>
				<?php if ( $this->config_applied['disable_server_signature'] ) {?>
					<span class="help-inline">
						<div class="applied">
							<?php echo JText::_('COM_SECURITYCHECKPRO_APPLIED') ?>
						</div>
					</span>
				<?php } ?>
			</div>
			<blockquote><p class="text-info"><small><?php echo JText::_('COM_SECURITYCHECKPRO_DISABLE_SERVER_SIGNATURE_EXPLAIN') ?></small></p></blockquote>
		</div>
		<div class="control-group">
			<label for="disallow_php_eggs" class="control-label-more-width" title="<?php echo JText::_('COM_SECURITYCHECKPRO_DISALLOW_PHP_EGGS_EXPLAIN') ?>"><?php echo JText::_('COM_SECURITYCHECKPRO_DISALLOW_PHP_EGGS_TEXT'); ?></label>
			<div class="controls controls-row">
				<?php echo booleanlist('disallow_php_eggs', array(), $this->protection_config['disallow_php_eggs']) ?>
				<?php if ( $this->config_applied['disallow_php_eggs'] ) {?>
					<span class="help-inline">
						<div class="applied">
							<?php echo JText::_('COM_SECURITYCHECKPRO_APPLIED') ?>
						</div>
					</span>
				<?php } ?>				
			</div>
			<blockquote><p class="text-info"><small><?php echo JText::_('COM_SECURITYCHECKPRO_DISALLOW_PHP_EGGS_EXPLAIN') ?></small></p></blockquote>
		</div>
		<div class="control-group">
			<label for="disallow_sensible_files_access" class="control-label-more-width" title="<?php echo JText::_('COM_SECURITYCHECKPRO_DISALLOW_SENSIBLE_FILES_ACCESS_EXPLAIN') ?>"><?php echo JText::_('COM_SECURITYCHECKPRO_DISALLOW_SENSIBLE_FILES_ACCESS_TEXT'); ?></label>
			<div class="controls controls-row">
				<?php echo booleanlist('disallow_sensible_files_access', array(), $this->protection_config['disallow_sensible_files_access']) ?>
				<?php if ( $this->config_applied['disallow_sensible_files_access'] ) {?>
					<span class="help-inline">
						<div class="applied">
							<?php echo JText::_('COM_SECURITYCHECKPRO_APPLIED') ?>
						</div>
					</span>
				<?php } ?>
			</div>
			<blockquote><p class="text-info"><small><?php echo JText::_('COM_SECURITYCHECKPRO_DISALLOW_SENSIBLE_FILES_ACCESS_EXPLAIN') ?></small></p></blockquote>
		</div>
	</fieldset>
	
	<fieldset>
		<legend><?php echo JText::_('COM_SECURITYCHECKPRO_BACKEND_PROTECTION_TEXT') ?></legend>
		
		<div class="alert alert-error">
			<?php echo JText::_('COM_SECURITYCHECKPRO_BACKEND_PROTECTION_EXPLAIN'); ?>	
		</div>
		
		<div class="control-group">
			<label for="hide_backend_url" class="control-label-more-width" title="<?php echo JText::_('COM_SECURITYCHECKPRO_HIDE_BACKEND_URL_EXPLAIN') ?>"><?php echo JText::_('COM_SECURITYCHECKPRO_HIDE_BACKEND_URL_TEXT'); ?></label>
			<div class="controls controls-row">
				<div class="input-prepend">
					<span class="add-on" style="background-color: #FFBF60;"><?php echo $site_url ?>?</span>
					<input class="input-large" type="text" name="hide_backend_url" id="hide_backend_url" value="<?php echo $this->protection_config['hide_backend_url']?>" placeholder="<?php echo $this->protection_config['hide_backend_url'] ?>">
				</div>
				<input type="submit" class="btn btn-primary" id="generate" value="<?php echo JText::_('COM_SECURITYCHECKPRO_HIDE_BACKEND_GENERATE_KEY_TEXT') ?>" />
				<?php if ( $this->config_applied['hide_backend_url'] ) {?>
					<span class="help-inline">
						<div class="applied">
							<?php echo JText::_('COM_SECURITYCHECKPRO_APPLIED') ?>
						</div>
					</span>
				<?php } ?>
			</div>
			<blockquote><p class="text-info"><small><?php echo JText::_('COM_SECURITYCHECKPRO_HIDE_BACKEND_URL_EXPLAIN') ?></small></p></blockquote>
		</div>
	</fieldset>
</form>

</div>